| Oyranos Colour Management System API

- Main Page
- Related Pages
- Modules
- Data Structures
- Files

- Data Structures
- Data Structure Index
- Class Hierarchy
- Data Fields

Public Member Functions | Data Fields
oyFilterNode_s Struct Reference
DAG and Image processing API

A FilterNode object. More...

`#include <oyFilterNode_s.h>`

Inheritance diagram for oyFilterNode_s:
Collaboration diagram for oyFilterNode_s:

## Public Member Functions
OYAPI oyFilterGraph_s *OYEXPORT | oyFilterGraph_FromNode (oyFilterNode_s *node, int flags)
| Get a graphs adjazency list. More...
OYAPI int OYEXPORT | oyFilterGraph_SetFromNode (oyFilterGraph_s *graph, oyFilterNode_s *node, const char *mark, int flags)
| Get a graphs adjazency list. More...
OYAPI oyFilterNode_s *OYEXPORT | oyFilterNode_New (oyObject_s object)
| allocate a new FilterNode object More...
OYAPI oyFilterNode_s *OYEXPORT | oyFilterNode_Copy (oyFilterNode_s *filternode, oyObject_s object)
| copy or reference a FilterNode object More...
OYAPI int OYEXPORT | oyFilterNode_Release (oyFilterNode_s **filternode)
| release and possibly deallocate a oyFilterNode_s object More...
int | oyFilterNode_Connect (oyFilterNode_s *input, const char *socket_nick, oyFilterNode_s *output, const char *plug_nick, int flags)
| Connect two nodes by a edge. More...
OYAPI int OYEXPORT | oyFilterNode_ConnectorMatch (oyFilterNode_s *node_first, int pos_first, oyFilterPlug_s *plug)
| Check if a connector match to a FilterNode. More...
oyFilterNode_s * | oyFilterNode_Create (oyFilterCore_s *filter, oyObject_s object)
| Initialise a new filter node object properly. More...
oyStruct_s * | oyFilterNode_GetData (oyFilterNode_s *node, int socket_pos)
| Get process data from a filter socket. More...
int | oyFilterNode_SetData (oyFilterNode_s *node, oyStruct_s *data, int socket_pos, oyObject_s *object)
| Set process data to a filter socket. More...
int | oyFilterNode_Disconnect (oyFilterNode_s *node, int pos)
| Disconnect two nodes by a edge. More...
int | oyFilterNode_EdgeCount (oyFilterNode_s *node, int is_input, int flags)
| Count real and potential connections to a filter node object. More...
OYAPI int OYEXPORT | oyFilterNode_GetConnectorPos (oyFilterNode_s *node, int is_input, const char *pattern, int nth_of_type, int flags)
| Get a oyFilterSocket_s or oyFilterPlug_s position from a FilterNode. More...
OYAPI int OYEXPORT | oyFilterNode_GetId (oyFilterNode_s *node)
| Get the object Id. More...
OYAPI oyFilterPlug_s *OYEXPORT | oyFilterNode_GetPlug (oyFilterNode_s *node, int pos)
| Get a oyFilterPlug_s of type from a FilterNode. More...
OYAPI int OYEXPORT | oyFilterNode_Run (oyFilterNode_s *node, oyFilterPlug_s *plug, oyPixelAccess_s *ticket)
| Run a connected oyFilterPlug_s through the FilterNode. More...
OYAPI oyFilterSocket_s *OYEXPORT | oyFilterNode_GetSocket (oyFilterNode_s *node, int pos)
| Get a oyFilterSocket_s of type from a FilterNode. More...
OYAPI oyFilterNode_s *OYEXPORT | oyFilterNode_GetSocketNode (oyFilterNode_s *node, int pos, int plugs_pos)
| Get a neighbouring oyFilterNode_s. More...
OYAPI int OYEXPORT | oyFilterNode_CountSocketNodes (oyFilterNode_s *node, int pos, int flags)
| Get a neighbouring oyFilterNode_s. More...
OYAPI oyFilterNode_s *OYEXPORT | oyFilterNode_GetPlugNode (oyFilterNode_s *node, int pos)
| Get a neighbouring oyFilterNode_s. More...
const char * | oyFilterNode_GetText (oyFilterNode_s *node, oyNAME_e name_type)
| Serialise filter node to text. More...
oyFilterNode_s * | oyFilterNode_NewWith (const char *registration, oyOptions_s *options, oyObject_s object)
| Initialise a new filter node object properly. More...
OYAPI oyConnector_s *OYEXPORT | oyFilterNode_ShowConnector (oyFilterNode_s *node, int as_pos, int is_plug)
| Get a connector description from a filter module. More...
OYAPI oyFilterCore_s *OYEXPORT | oyFilterNode_GetCore (oyFilterNode_s *node)
| Get filter core. More...
OYAPI const char *OYEXPORT | oyFilterNode_GetRegistration (oyFilterNode_s *node)
| Get filter core registration. More...
OYAPI const char *OYEXPORT | oyFilterNode_GetRelatives (oyFilterNode_s *node)
| Get filter relatives string. More...
OYAPI const char *OYEXPORT | oyFilterNode_GetModuleName (oyFilterNode_s *node)
| Get filter core module string. More...
OYAPI oyPointer_s *OYEXPORT | oyFilterNode_GetModuleData (oyFilterNode_s *node)
| Get module data. More...
OYAPI int OYEXPORT | oyFilterNode_SetModuleData (oyFilterNode_s *node, oyPointer_s *data)
| Set module data. More...
OYAPI oyOptions_s *OYEXPORT | oyFilterNode_GetTags (oyFilterNode_s *node)
| Get filter tags. More...
oyOptions_s * | oyFilterNode_GetOptions (oyFilterNode_s *node, int flags)
| Get filter options. More...
int | oyFilterNode_GetUi (oyFilterNode_s *node, char **ui_text, char ***namespaces, oyAlloc_f allocateFunc)
| Get filter options XFORMS. More...
Public Member Functions inherited from oyStruct_s
const char * | oyStruct_GetText (oyStruct_s *obj, oyNAME_e name_type, uint32_t flags)
| get a text dump More...

## Data Fields
oyStruct_Copy_f | copy
oyStruct_Release_f | release
Data Fields inherited from oyStruct_s
oyStruct_Copy_f | copy
oyStruct_Release_f | release

## Detailed Description

A FilterNode object.

## Member Function Documentation

OYAPI oyFilterGraph_s *OYEXPORT oyFilterGraph_FromNode | ( | oyFilterNode_s * | node,
|  | int | flags
| ) |  |

Get a graphs adjazency list.

Function oyFilterGraph_FromNode

Parameters

  [in] | node | filter node
  [in] | flags | - OY_INPUT omit input direction OY_OUTPUT omit output direction

Returns
  the graph

Version
  Oyranos: 0.1.10

Since
  2009/02/25 (Oyranos: 0.1.10)

Date
  2009/10/28

References oyFilterGraph_s::oyFilterGraph_New(), oyFilterGraph_SetFromNode(), and oyOBJECT_FILTER_NODE_S.

Referenced by oyConversion_s::oyConversion_GetGraph(), oyFilterSocket_s::oyFilterSocket_SignalToGraph(), and oyPixelAccess_s::oyPixelAccess_Create().

OYAPI int OYEXPORT oyFilterGraph_SetFromNode | ( | oyFilterGraph_s * | graph,
|  | oyFilterNode_s * | node,
|  | const char * | mark,
|  | int | flags
| ) |  |

Get a graphs adjazency list.

Function oyFilterGraph_SetFromNode

Parameters

  [in] | graph | a graph object
  [in] | node | filter node
  [in] | mark | a selection
  [in] | flags | - OY_INPUT omit input direction OY_OUTPUT omit output direction

Returns
  the graph

Version
  Oyranos: 0.1.10

Since
  2009/03/04 (Oyranos: 0.1.10)

Date
  2009/03/04

References oyFilterNodes_s::oyFilterNodes_New(), oyFilterNodes_s::oyFilterNodes_Release(), oyFilterPlugs_s::oyFilterPlugs_New(), oyFilterPlugs_s::oyFilterPlugs_Release(), and oyOBJECT_FILTER_GRAPH_S.

Referenced by oyConversion_s::oyConversion_RunPixels(), oyConversion_s::oyConversion_ToText(), and oyFilterGraph_FromNode().

int oyFilterNode_Connect | ( | oyFilterNode_s * | input,
|  | const char * | socket_nick,
|  | oyFilterNode_s * | output,
|  | const char * | plug_nick,
|  | int | flags
| ) |  |

Connect two nodes by a edge.

Function oyFilterNode_Connect

Parameters

  input | the node to provide a socket
  socket_nick | name of socket
  output | the node providing a plug
  plug_nick | name of plug
  flags | unused

Returns
  error

Version
  Oyranos: 0.1.10

Since
  2009/02/26 (Oyranos: 0.1.10)

Date
  2009/02/26

References oyFilterCore_s::oyFilterCore_GetName(), oyFilterNode_ConnectorMatch(), oyFilterNode_EdgeCount(), oyFilterNode_GetConnectorPos(), oyFilterNode_GetPlug(), oyFilterNode_GetSocket(), oyFilterPlug_s::oyFilterPlug_ConnectIntoSocket(), oyNAME_NAME, and oyOBJECT_FILTER_NODE_S.

Referenced by oyConversion_s::oyConversion_CreateBasicPixels(), oyConversion_CreateFromImage(), oyImage_FromFile(), and oyImage_ToFile().

OYAPI int OYEXPORT oyFilterNode_ConnectorMatch | ( | oyFilterNode_s * | node_first,
|  | int | pos_first,
|  | oyFilterPlug_s * | plug
| ) |  |

Check if a connector match to a FilterNode.

Function oyFilterNode_ConnectorMatch

Parameters

  node_first | first node
  pos_first | position of connector from first node
  plug | second connector

Version
  Oyranos: 0.1.8

Since
  2008/07/29 (Oyranos: 0.1.8)

Date
  2008/07/29

Check if basic types match.

More detailed checking is done in oyCMMapi5_s.

References oyConnector_s::oyConnector_GetMatch(), oyConnector_s::oyConnector_GetReg(), oyConnector_s::oyConnector_Release(), oyFILTER_REG_TYPE, oyFilterNode_GetSocket(), oyFilterNode_ShowConnector(), oyFilterRegistrationMatch(), oyFilterRegistrationToText(), oyFilterSocket_s::oyFilterSocket_Release(), and oyOBJECT_FILTER_NODE_S.

Referenced by oyFilterNode_Connect().

OYAPI oyFilterNode_s *OYEXPORT oyFilterNode_Copy | ( | oyFilterNode_s * | filternode,
|  | oyObject_s | object
| ) |  |

copy or reference a FilterNode object

Function oyFilterNode_Copy

The function is for copying and for referencing. The reference is the most often used way, which saves resourcs and time.

Parameters

  [in] | filternode | FilterNode struct object
  | object | NULL - means reference, the optional object triggers a real copy

References oyOBJECT_FILTER_NODE_S.

Referenced by oyConversion_s::oyConversion_GetNode(), oyFilterNode_GetPlug(), oyFilterNode_GetPlugNode(), oyFilterNode_GetSocket(), oyFilterNode_GetSocketNode(), oyFilterPlug_s::oyFilterPlug_GetNode(), and oyFilterSocket_s::oyFilterSocket_GetNode().

OYAPI int OYEXPORT oyFilterNode_CountSocketNodes | ( | oyFilterNode_s * | node,
|  | int | pos,
|  | int | flags
| ) |  |

Get a neighbouring oyFilterNode_s.

Function oyFilterNode_CountSocketNodes

Parameters

  node | filter node
  pos | connector position
  flags | specify which number to return oyranos::OY_FILTEREDGE_FREE: count available oyranos::OY_FILTEREDGE_CONNECTED: count used oyranos::OY_FILTEREDGE_LASTTYPE: account only for the last connector type

Returns
  the number of possible edges

Version
  Oyranos: 0.5.0

Since
  2012/10/03 (Oyranos: 0.5.0)

Date
  2012/10/03

References oyFilterPlugs_s::oyFilterPlugs_Count(), and oyOBJECT_FILTER_NODE_S.

oyFilterNode_s * oyFilterNode_Create | ( | oyFilterCore_s * | filter,
|  | oyObject_s | object
| ) |  |

Initialise a new filter node object properly.

Function oyFilterNode_Create

Parameters

  filter | the mandatory filter
  object | the optional object

Version
  Oyranos: 0.1.8

Since
  2008/07/30 (Oyranos: 0.1.8)

Date
  2008/07/30 TODO select oyCMMapi7_s over registration string

References oyFilterCore_s::oyFilterCore_Copy(), oyFilterNode_EdgeCount(), oyFilterNode_New(), oyFilterNode_Release(), and oyOBJECT_CMM_API7_S.

Referenced by oyFilterNode_NewWith().

int oyFilterNode_Disconnect | ( | oyFilterNode_s * | node,
|  | int | pos
| ) |  |

Disconnect two nodes by a edge.

Function oyFilterNode_Disconnect

Parameters

  node | a node
  pos | the plug number to release

Returns
  error

Version
  Oyranos: 0.5.0

Date
  2012/09/25

Since
  2009/03/04 (Oyranos: 0.1.10)

References oyFilterSocket_s::oyFilterSocket_Callback(), oyFilterSocket_s::oyFilterSocket_Release(), and oyOBJECT_FILTER_NODE_S.

int oyFilterNode_EdgeCount | ( | oyFilterNode_s * | node,
|  | int | is_input,
|  | int | flags
| ) |  |

Count real and potential connections to a filter node object.

Function oyFilterNode_EdgeCount

Parameters

  node | the node
  is_input | 1 - plugs; 0 - sockets
  flags | specify which number to return oyranos::OY_FILTEREDGE_FREE: count available oyranos::OY_FILTEREDGE_CONNECTED: count used oyranos::OY_FILTEREDGE_LASTTYPE: account only for the last connector type

Returns
  the number of possible edges

Version
  Oyranos: 0.1.10

Since
  2009/02/24 (Oyranos: 0.1.10)

Date
  2009/02/27

References oyFilterPlugs_s::oyFilterPlugs_Count(), and oyOBJECT_FILTER_NODE_S.

Referenced by oyFilterGraph_s::oyFilterGraph_ToText(), oyFilterNode_Connect(), oyFilterNode_Create(), oyFilterNode_GetPlug(), oyFilterNode_GetSocket(), oyFilterNode_ShowConnector(), and oyFilterSocket_s::oyFilterSocket_SignalToGraph().

OYAPI int OYEXPORT oyFilterNode_GetConnectorPos | ( | oyFilterNode_s * | node,
|  | int | is_input,
|  | const char * | pattern,
|  | int | nth_of_type,
|  | int | flags
| ) |  |

Get a oyFilterSocket_s or oyFilterPlug_s position from a FilterNode.

Function oyFilterNode_GetConnectorPos

Parameters

  node | filter node
  is_input | 1 - plugs; 0 - sockets
  pattern | the pattern to be found in the oyConnector_s::connector_type of the searched plug or socket. Its a registration string. E.g. a typical data connection: "//" OY_TYPE_STD "/data" See as well oyranos::oyCONNECTOR_e.
  nth_of_type | the position in the group of the connector type for this filter; Note this parameter makes only sense for the last filter defined connector, as only this one can occure multiple times.
  flags | specify which status to return zero means: take all into account oyranos::OY_FILTEREDGE_FREE: next free available oyranos::OY_FILTEREDGE_CONNECTED: consider used

Returns
  the absolute position

Version
  Oyranos: 0.1.10

Since
  2009/02/26 (Oyranos: 0.1.10)

Date
  2009/11/02

References oyConnector_s::oyConnector_GetReg(), oyFilterPlugs_s::oyFilterPlugs_Count(), oyFilterRegistrationMatch(), and oyOBJECT_FILTER_NODE_S.

Referenced by oyFilterNode_Connect(), and oyFilterSocket_s::oyFilterSocket_SignalToGraph().

OYAPI oyFilterCore_s *OYEXPORT oyFilterNode_GetCore | ( | oyFilterNode_s * | node | ) |

Get filter core.

Function oyFilterNode_GetCore

Parameters

  [in,out] | node | filter object

Returns
  the core

Version
  Oyranos: 0.5.0

Date
  2012/09/15

Since
  2012/09/15 (Oyranos: 0.1.10)

References oyFilterCore_s::oyFilterCore_Copy(), and oyOBJECT_FILTER_NODE_S.

Referenced by oyFilterGraph_s::oyFilterGraph_ToText().

oyStruct_s * oyFilterNode_GetData | ( | oyFilterNode_s * | node,
|  | int | socket_pos
| ) |  |

Get process data from a filter socket.

Function oyFilterNode_GetData

Parameters

  [in] | node | filter node
  [in] | socket_pos | position of socket

Returns
  the data

Version
  Oyranos: 0.1.10

Since
  2009/03/05 (Oyranos: 0.1.10)

Date
  2009/03/05

References oyStruct_s::copy, oyFilterNode_GetSocket(), oyFilterSocket_s::oyFilterSocket_Release(), and oyOBJECT_FILTER_NODE_S.

OYAPI int OYEXPORT oyFilterNode_GetId | ( | oyFilterNode_s * | node | ) |

Get the object Id.

Function oyFilterNode_GetId

Parameters

  [in] | node | filter node

Returns
  the object Id

Version
  Oyranos: 0.1.10

Since
  2009/02/25 (Oyranos: 0.1.10)

Date
  2009/02/25

References oyOBJECT_FILTER_NODE_S.

Referenced by oyFilterGraph_s::oyFilterGraph_ToText().

OYAPI oyPointer_s *OYEXPORT oyFilterNode_GetModuleData | ( | oyFilterNode_s * | node | ) |

Get module data.

Function oyFilterNode_GetModuleData

the filters private data, requested over oyCMMapi4_s::oyCMMFilterNode_ContextToMem() and converted to oyCMMapi4_s::context_type

Parameters

  [in,out] | node | filter object

Returns
  the data

Version
  Oyranos: 0.5.0

Date
  2012/10/04

Since
  2012/10/04 (Oyranos: 0.5.0)

References oyOBJECT_FILTER_NODE_S, and oyPointer_s::oyPointer_Copy().

OYAPI const char *OYEXPORT oyFilterNode_GetModuleName | ( | oyFilterNode_s * | node | ) |

Get filter core module string.

Function oyFilterNode_GetModuleName

Parameters

  [in,out] | node | filter object

Returns
  the debug string

Version
  Oyranos: 0.5.0

Date
  2012/10/04

Since
  2012/10/04 (Oyranos: 0.5.0)

References oyOBJECT_FILTER_NODE_S.

oyOptions_s * oyFilterNode_GetOptions | ( | oyFilterNode_s * | node,
|  | int | flags
| ) |  |

Get filter options.

Function oyFilterNode_GetOptions

Options are typical user visible settings, which can be presistently stored as user preferences and can be displayed in filter dialogs.

Parameters

  [in,out] | node | filter object
  | flags | see oyOptions_s::oyOptions_ForFilter()

Returns
  the options

Version
  Oyranos: 0.5.0

Since
  2008/06/26 (Oyranos: 0.1.8)

Date
  2012/06/12

Observe exported options for changes and propagate to a existing graph.

References oyBOOLEAN_UNION, oyOBJECT_FILTER_NODE_S, oyOptions_s::oyOptions_Copy(), oyOptions_s::oyOptions_Filter(), oyOptions_s::oyOptions_ForFilter_(), oyOptions_s::oyOptions_New(), and oyOptions_s::oyOptions_ObserverAdd().

Referenced by oyFilterNode_GetUi(), oyFilterPlug_s::oyFilterPlug_ResolveImage(), oyImage_FromFile(), and oyImage_ToFile().

OYAPI oyFilterPlug_s *OYEXPORT oyFilterNode_GetPlug | ( | oyFilterNode_s * | node,
|  | int | pos
| ) |  |

Get a oyFilterPlug_s of type from a FilterNode.

Function oyFilterNode_GetPlug

Parameters

  node | filter node
  pos | position of connector from filter

Returns
  the plug

Version
  Oyranos: 0.1.8

Since
  2008/07/30 (Oyranos: 0.1.8)

Date
  2008/07/30

References oyFilterNode_Copy(), oyFilterNode_EdgeCount(), oyFilterNode_ShowConnector(), oyFilterPlug_s::oyFilterPlug_Copy(), oyFilterPlug_s::oyFilterPlug_New(), and oyOBJECT_FILTER_NODE_S.

Referenced by oyConversion_s::oyConversion_GetImage(), oyConversion_s::oyConversion_GetOnePixel(), oyConversion_s::oyConversion_RunPixels(), oyFilterNode_Connect(), and oyFilterSocket_s::oyFilterSocket_SignalToGraph().

OYAPI oyFilterNode_s *OYEXPORT oyFilterNode_GetPlugNode | ( | oyFilterNode_s * | node,
|  | int | pos
| ) |  |

Get a neighbouring oyFilterNode_s.

Function oyFilterNode_GetPlugNode

Parameters

  node | filter node
  pos | connector position

Returns
  the node

Version
  Oyranos: 0.5.0

Since
  2012/10/03 (Oyranos: 0.5.0)

Date
  2012/10/03

References oyFilterNode_Copy(), and oyOBJECT_FILTER_NODE_S.

OYAPI const char *OYEXPORT oyFilterNode_GetRegistration | ( | oyFilterNode_s * | node | ) |

Get filter core registration.

Function oyFilterNode_GetRegistration

Parameters

  [in,out] | node | filter object

Returns
  the registration string

Version
  Oyranos: 0.5.0

Date
  2012/09/15

Since
  2012/09/15 (Oyranos: 0.5.0)

References oyOBJECT_FILTER_NODE_S.

Referenced by oyFilterGraph_s::oyFilterGraph_ToText().

OYAPI const char *OYEXPORT oyFilterNode_GetRelatives | ( | oyFilterNode_s * | node | ) |

Get filter relatives string.

Function oyFilterNode_GetRelatives

Parameters

  [in,out] | node | filter object

Returns
  the debug string

Version
  Oyranos: 0.5.0

Date
  2012/10/04

Since
  2012/10/04 (Oyranos: 0.5.0)

References oyOBJECT_FILTER_NODE_S.

OYAPI oyFilterSocket_s *OYEXPORT oyFilterNode_GetSocket | ( | oyFilterNode_s * | node,
|  | int | pos
| ) |  |

Get a oyFilterSocket_s of type from a FilterNode.

Function oyFilterNode_GetSocket

Parameters

  node | filter node
  pos | absolute position of connector

Returns
  the socket

Version
  Oyranos: 0.1.8

Since
  2008/07/30 (Oyranos: 0.1.8)

Date
  2008/07/30

References oyFilterNode_Copy(), oyFilterNode_EdgeCount(), oyFilterNode_ShowConnector(), oyFilterSocket_s::oyFilterSocket_Copy(), oyFilterSocket_s::oyFilterSocket_New(), and oyOBJECT_FILTER_NODE_S.

Referenced by oyConversion_s::oyConversion_GetImage(), oyFilterGraph_s::oyFilterGraph_ToText(), oyFilterNode_Connect(), oyFilterNode_ConnectorMatch(), oyFilterNode_GetData(), and oyFilterNode_SetData().

OYAPI oyFilterNode_s *OYEXPORT oyFilterNode_GetSocketNode | ( | oyFilterNode_s * | node,
|  | int | pos,
|  | int | plugs_pos
| ) |  |

Get a neighbouring oyFilterNode_s.

Function oyFilterNode_GetSocketNode

Parameters

  node | filter node
  pos | connector position
  plugs_pos | position in plug list

Returns
  the node

Version
  Oyranos: 0.5.0

Since
  2012/10/03 (Oyranos: 0.5.0)

Date
  2012/10/03

References oyFilterNode_Copy(), oyFilterPlug_s::oyFilterPlug_Release(), oyFilterPlugs_s::oyFilterPlugs_Get(), and oyOBJECT_FILTER_NODE_S.

OYAPI oyOptions_s *OYEXPORT oyFilterNode_GetTags | ( | oyFilterNode_s * | node | ) |

Get filter tags.

Function oyFilterNode_GetTags

Tags are non persistent informations. Typical they are not directly user visible other than filter core options, which can appear inside dialogs.

Parameters

  [in,out] | node | filter object

Returns
  the tags

Version
  Oyranos: 0.5.0

Date
  2012/09/15

Since
  2012/09/15 (Oyranos: 0.5.0)

References oyOBJECT_FILTER_NODE_S, oyOptions_s::oyOptions_Copy(), and oyOptions_s::oyOptions_New().

const char * oyFilterNode_GetText | ( | oyFilterNode_s * | node,
|  | oyNAME_e | name_type
| ) |  |

Serialise filter node to text.

Function oyFilterNode_GetText

Serialise into:

- oyNAME_NICK: XML ID
- oyNAME_NAME: XML from module
- oyNAME_DESCRIPTION: ??

This function provides a complete description of the context. It might be more adequate to use only a subset for hashing as not all data and options might have an effect to the context data result. The oyCMMapi4_s::oyCMMFilterNode_GetText() function provides a way to let a module decide about what to place into a hash text.

Parameters

  [in,out] | node | filter node
  [out] | name_type | the type

Returns
  the text

Version
  Oyranos: 0.3.3

Date
  2011/11/22

Since
  2008/07/17 (Oyranos: 0.1.8)

References oyContextCollectData_(), oyFilterCore_s::oyFilterCore_GetText(), oyNAME_NAME, and oyNAME_NICK.

int oyFilterNode_GetUi | ( | oyFilterNode_s * | node,
|  | char ** | ui_text,
|  | char *** | namespaces,
|  | oyAlloc_f | allocateFunc
| ) |  |

Get filter options XFORMS.

Function oyFilterNode_GetUi

Parameters

  [in,out] | node | filter object
  [out] | ui_text | XFORMS fitting to the node Options
  [out] | namespaces | additional XML namespaces
  | allocateFunc | optional user allocator

Returns
  the options

Version
  Oyranos: 0.5.0

Since
  2009/07/29 (Oyranos: 0.1.10)

Date
  2012/06/12

References oyFILTER_REG_TYPE, oyFilterNode_GetOptions(), oyFilterRegistrationMatch(), oyFilterRegistrationToText(), oyOBJECT_CMM_API9_S, oyOBJECT_FILTER_NODE_S, and oyOptions_s::oyOptions_Release().

OYAPI oyFilterNode_s *OYEXPORT oyFilterNode_New | ( | oyObject_s | object | ) |

allocate a new FilterNode object

Function oyFilterNode_New

References oyOBJECT_OBJECT_S.

Referenced by oyFilterNode_Create().

oyFilterNode_s * oyFilterNode_NewWith | ( | const char * | registration,
|  | oyOptions_s * | options,
|  | oyObject_s | object
| ) |  |

Initialise a new filter node object properly.

Function oyFilterNode_NewWith

Parameters

  registration | a registration string,

See also
  module_api

Parameters

  options | options for the filter
  object | the optional object

Version
  Oyranos: 0.1.10

Since
  2009/03/05 (Oyranos: 0.1.10)

Date
  2009/06/24

References oyFilterCore_s::oyFilterCore_NewWith(), oyFilterCore_s::oyFilterCore_Release(), and oyFilterNode_Create().

Referenced by oyConversion_s::oyConversion_CreateBasicPixels(), oyConversion_CreateFromImage(), oyImage_FromFile(), and oyImage_ToFile().

OYAPI int OYEXPORT oyFilterNode_Release | ( | oyFilterNode_s ** | filternode | ) |

release and possibly deallocate a oyFilterNode_s object

Function oyFilterNode_Release

Parameters

  [in,out] | filternode | FilterNode struct object

References oyOBJECT_FILTER_NODE_S.

Referenced by oyFilterGraph_s::oyFilterGraph_CountNodes(), oyFilterGraph_s::oyFilterGraph_GetNode(), oyFilterGraph_s::oyFilterGraph_PrepareContexts(), oyBlob_s::oyFilterGraph_ToBlob(), oyFilterGraph_s::oyFilterGraph_ToText(), oyFilterNode_Create(), and oyFilterSocket_s::oyFilterSocket_SignalToGraph().

OYAPI int OYEXPORT oyFilterNode_Run | ( | oyFilterNode_s * | node,
|  | oyFilterPlug_s * | plug,
|  | oyPixelAccess_s * | ticket
| ) |  |

Run a connected oyFilterPlug_s through the FilterNode.

Function oyFilterNode_Run

Parameters

  node | filter node
  plug | the plug
  ticket | the job ticket

Returns
  error

Version
  Oyranos: 0.5.0

Date
  2012/09/24

Since
  2012/09/24 (Oyranos: 0.5.0)

References oyOBJECT_FILTER_NODE_S.

int oyFilterNode_SetData | ( | oyFilterNode_s * | node,
|  | oyStruct_s * | data,
|  | int | socket_pos,
|  | oyObject_s * | object
| ) |  |

Set process data to a filter socket.

Function oyFilterNode_SetData

Parameters

  [in,out] | node | filter node
  [in] | data | data
  [in] | socket_pos | position of socket
  [in] | object | a object to not only set a reference

Returns
  error

Version
  Oyranos: 0.1.10

Since
  2009/03/05 (Oyranos: 0.1.10)

Date
  2009/03/05

References oyStruct_s::copy, oyFilterNode_GetSocket(), oyFilterSocket_s::oyFilterSocket_Release(), oyOBJECT_FILTER_NODE_S, and oyFilterSocket_s::release.

Referenced by oyConversion_s::oyConversion_CreateBasicPixels(), oyConversion_CreateFromImage(), oyFilterPlug_s::oyFilterPlug_ResolveImage(), and oyImage_ToFile().

OYAPI int OYEXPORT oyFilterNode_SetModuleData | ( | oyFilterNode_s * | node,
|  | oyPointer_s * | data
| ) |  |

Set module data.

Function oyFilterNode_SetModuleData

the filters private data, requested over oyCMMapi4_s::oyCMMFilterNode_ContextToMem() and converted to oyCMMapi4_s::context_type

Parameters

  [in,out] | node | filter object

Returns
  the data

Version
  Oyranos: 0.5.0

Date
  2012/10/04

Since
  2012/10/04 (Oyranos: 0.5.0)

References oyOBJECT_FILTER_NODE_S, oyPointer_s::oyPointer_Copy(), and oyPointer_s::oyPointer_Release().

OYAPI oyConnector_s *OYEXPORT oyFilterNode_ShowConnector | ( | oyFilterNode_s * | node,
|  | int | as_pos,
|  | int | is_plug
| ) |  |

Get a connector description from a filter module.

Function oyFilterNode_ShowConnector

The path to obtain a new connector. The filter can say it has more connectors to provide for a certain kind of static connector eigther described in oyCMMapi4_s::inputs or oyCMMapi4_s::outputs.

Parameters

  [in] | node | the module filter node
  [in] | as_pos | the according oyConnector_s
  [in] | is_plug | select from 0 - plugs or 1 - sockets

Returns
  the new oyConnector_s

Version
  Oyranos: 0.1.10

Since
  2008/07/28 (Oyranos: 0.1.8)

Date
  2008/12/27

References oyConnector_s::oyConnector_Copy(), oyFilterNode_EdgeCount(), and oyOBJECT_FILTER_NODE_S.

Referenced by oyFilterNode_ConnectorMatch(), oyFilterNode_GetPlug(), and oyFilterNode_GetSocket().

## Field Documentation

oyStruct_Copy_f oyFilterNode_s::copy

copy function

oyStruct_Release_f oyFilterNode_s::release

release function